<html>
<head>
<link rel="stylesheet" type="text/css" href="style.css" />
<title>Luiz's Junk Code</title>
</head>
<body>

<h2 align="center">Junk Code</h2>

<p>My junk code repository has some small projects and several code examples
in C, C++, C#, Python, Bash and AWK.</p>

<p>The most interesting ones are listed below and the repository information
is at the end of this page.</p>

<h4><a href="http://repo.or.cz/w/lcapit-junk-code.git?a=tree;f=linux-kernel;h=cdca626ada7a06e0459f73447201a369d6e958d8;hb=HEAD">Linux kernel code</a></h4>

<blockquote>
Some time ago I have tried to port the USB Serial layer to use the Serial
Core subsystem but it showed some problems with the fact that USB devices
have to sleep when changing device settings... Anyway, the original pachset
is <a href="http://repo.or.cz/w/lcapit-junk-code.git?a=tree;f=linux-kernel/PATCHES/serial-core-port-V0;h=624cbfd35598c75c54a3eb94717498113b8c785d;hb=HEAD">here</a>
and I have written two drivers to understand how the Serial Core and TTY
subsystems work, code is <a href="http://repo.or.cz/w/lcapit-junk-code.git?a=tree;f=linux-kernel/fake-serial;h=5156007bccd4aad615bf1a3f6d1c8dfcdb3751bb;hb=HEAD">here</a>.
</blockquote>

<blockquote>
Besides that the linux-kernel directory has examples of debugfs, netlink,
rbtree and others.
</blockquote>

<h4><a href="http://repo.or.cz/w/lcapit-junk-code.git?a=tree;f=books/mawc;h=16a11de9fa2c7ebadfaf1273a9f55b1ea1994cc6;hb=HEAD">Basic data structures</a></h4>

<blockquote>
There are examples of lists (singly-linked, doubly-linked and circulary-linked),
queue, stack, hash-tables and binary-tree.
</blockquote>

<h4><a href="http://repo.or.cz/w/lcapit-junk-code.git?a=tree;f=CEP;h=52e280c4271c59f027fb027b2f457129ee4a8b05;hb=HEAD">CEP program</a></h4>

<blockquote>
I have written a program to search for an address in
<a href="http://en.wikipedia.org/wiki/Curitiba">Curitiba</a> given the CEP
number (Brazil's post code system). The program can use the following data
structures to store the addresses information:

<ul>
<li>Singly-linked list</li>
<li>Binary search tree</li>
<li>AVL tree</li>
<li>AA tree</li>
</ul> 

The user can choose the data structure in the command-line. There is also a
version in Python and C# with different data structures.
</blockquote>

<h4><a href="http://repo.or.cz/w/lcapit-junk-code.git?a=tree;f=static-data-structures;h=45489df03b48c87ed42859508d285ffcafd3a1d5;hb=HEAD">Static data structures</a></h4>

<blockquote>
Sometimes, when you are writting a program or library, you need to use something
better than an array to store data but you do not want to use dynamic memory
or anything complicated.
</blockquote>

<blockquote>
The solution is to use the "static version" of some known data structure.
</blockquote>

<h4><a href="http://repo.or.cz/w/lcapit-junk-code.git?a=tree;f=mega-sena;h=94b5b78808397f6c8f3b81773bb8b3b4b17f4b0c;hb=HEAD">Mega Sena program</a></h4>

<blockquote>
Mega-Sena is the name of Brazil's most valuable national loterry. I have
written a program which reads all the Mega-Sena results in memory (they
are available in the Web) and does the loterry.
</blockquote>

<blockquote>
The program uses a hash table to store its data, and the user can choose
the following types of hash-tables:

<ul>
<li>Open Addressing (linear probing)</li>
<li>Cuckoo hashing</li>
</ul> 

</blockquote>

<h3>Repository</h3>

<ul>
<li><a href="http://repo.or.cz/w/lcapit-junk-code.git?a=tree">Browse</a> the source code</li>
<li>Repository page:
<a href="http://repo.or.cz/w/lcapit-junk-code.git">http://repo.or.cz/w/lcapit-junk-code.git</a></li>
<li>Clone command: $ git clone git://repo.or.cz/lcapit-junk-code.git</li>
</ul>

</body>
</html>
